import math
from python_matrix_operations import *
import ctypes
import os
import sys
#---------------------------------------------------------------



#--- define indicator function for material phases
# x[0] : y1-component
# x[1] : y2-component
# x[2] : x3-component
#To indicate phases return either : 1 / 2 / 3
###############
# Cross
###############
def indicatorFunction(x):
    theta=0.25
    factor=1
    if (x[0] <-0.5+theta and x[2]<-0.5+theta):
        return 1    #Phase1
    elif (x[1]<-0.5+theta and x[2]>0.5-theta):
        return 2    #Phase2
    else :
        return 3   #Phase3

###############
# Wood
###############
# def f(x):
#     theta=0.25
    # if ((abs(x[0]) < theta/2) and x[2]<0.25):
    #     return 1    #latewood
    # elif ((abs(x[0]) > theta/2) and x[2]<0.25):
    #     return 2    #earlywood
    # else :
    #     return 0    #Phase3


########### Options for material phases: #################################
#     1. "isotropic"     2. "orthotropic"      3. "transversely_isotropic"   4. "general_anisotropic"
#########################################################################
## Notation - Parameter input :
# isotropic (Lame parameters) : [mu , lambda]
#         orthotropic         : [E1,E2,E3,G12,G23,G31,nu12,nu13,nu23]
# transversely_isotropic      : [E1,E2,G12,nu12,nu23]
# general_anisotropic         : full compliance matrix C
######################################################################
# --- Number of material phases
Phases=3
#--- Define different material phases:
#- PHASE 1
phase1_type="isotropic"
materialParameters_phase1 = [80, 80]

#- PHASE 2
phase2_type="isotropic"
materialParameters_phase2 = [80, 80]

#- PHASE 3
phase3_type="isotropic"
materialParameters_phase3 = [60, 25]


#--- define prestrain function for each phase
# (also works with non-constant values)
def prestrain_phase1(x):
    return [[1, 0, 0], [0,1,0], [0,0,1]]

def prestrain_phase2(x):
    return [[1, 0, 0], [0,1,0], [0,0,1]]

def prestrain_phase3(x):
    return [[0, 0, 0], [0,0,0], [0,0,0]]
    # return [[x[0],0 ,0 ], [0,0,x[1]], [0,0,x[2]]]
